---
title: OpenSearch description format
slug: Web/OpenSearch
tags:
  - Add-ons
  - Guide
  - OpenSearch
  - Search
  - Search plugins
  - Web
  - Web Standards
---
<p>{{AddonSidebar}}</p>

<p><span class="seoSummary">The <strong><a href="https://github.com/dewitt/opensearch" rel="external">OpenSearch description format</a></strong> lets a website describe a search engine for itself, so that a browser or other client application can use that search engine.</span> OpenSearch is supported by (at least) Firefox, Edge, Internet Explorer, Safari, and Chrome. (See <a href="#Reference_Material">Reference Material</a> for links to other browsers' documentation.)</p>

<p>Firefox also supports additional features not in the OpenSearch standard, such as search suggestions and the <code>&lt;SearchForm&gt;</code> element. This article focuses on creating OpenSearch-compatible search plugins that support these additional Firefox features.</p>

<p>OpenSearch description files can be advertised as described in <a href="#Autodiscovery_of_search_plugins">Autodiscovery of search plugins</a>, and can be installed programmatically as described in <a href="/en/Adding_search_engines_from_web_pages">Adding search engines from web pages</a>.</p>

<h2 id="OpenSearch_description_file">OpenSearch description file</h2>

<p>The XML file that describes a search engine follows the basic template below. Sections in <em>[square brackets]</em> should be customized for the specific plugin you're writing.</p>

<pre class="brush: xml">&lt;OpenSearchDescription xmlns="http://a9.com/-/spec/opensearch/1.1/"
                       xmlns:moz="http://www.mozilla.org/2006/browser/search/"&gt;
  &lt;ShortName&gt;<mark><strong>[SNK]</strong></mark>&lt;/ShortName&gt;
  &lt;Description&gt;<mark><strong>[Search engine full name and summary]</strong></mark>&lt;/Description&gt;
  &lt;InputEncoding&gt;<mark><strong>[UTF-8]</strong></mark>&lt;/InputEncoding&gt;
  &lt;Image width="16" height="16" type="image/x-icon"&gt;<mark><strong>[https://example.com/favicon.ico]</strong></mark>&lt;/Image&gt;
  &lt;Url type="text/html" template="<mark><strong>[searchURL]</strong></mark>"&gt;
    &lt;Param name="<mark><strong>[key name]</strong></mark>" value="{searchTerms}"/&gt;
    &lt;!-- other Params if you need them… --&gt;
    &lt;Param name="<mark><strong>[other key name]</strong></mark>" value="<mark><strong>[parameter value]</strong></mark>"/&gt;
  &lt;/Url&gt;
  &lt;Url type="application/x-suggestions+json" template="<mark><strong>[suggestionURL]</strong></mark>"/&gt;
  &lt;moz:SearchForm&gt;<mark><strong>[https://example.com/search]</strong></mark>&lt;/moz:SearchForm&gt;
&lt;/OpenSearchDescription&gt;</pre>

<dl>
 <dt>ShortName</dt>
 <dd>A short name for the search engine. It must be <strong>16 or fewer character</strong>s of plain text, with no HTML or other markup.</dd>
 <dt>Description</dt>
 <dd>A brief description of the search engine. It must be <strong>1024 or fewer characters</strong> of plain text, with no HTML or other markup.</dd>
 <dt>InputEncoding</dt>
 <dd>The <a href="/en-US/docs/Glossary/character_encoding">character encoding</a> to use when submitting input to the search engine.</dd>
 <dt>Image</dt>
 <dd>
 <p>URI of an icon for the search engine. When possible, include a 16×16 image of type <code>image/x-icon</code> (such as <code>/favicon.ico</code>) and a 64×64 image of type <code>image/jpeg</code> or <code>image/png</code>.</p>

 <p>The URI may also use the <a href="/en-US/docs/Web/HTTP/data_URIs"><code>data:</code> URI scheme</a>. (You can generate a <code>data:</code> URI from an icon file at <a class="external" href="http://software.hixie.ch/utilities/cgi/data/data">The <code>data:</code> URI kitchen</a>.)</p>

 <pre class="brush: xml">&lt;Image height="16" width="16" type="image/x-icon"&gt;https://example.com/favicon.ico&lt;/Image&gt;
  &lt;!-- or --&gt;
&lt;Image height="16" width="16"&gt;data:image/x-icon;base64,AAABAAEAEBAAA … DAAA=&lt;/Image&gt;
</pre>

 <p>Firefox caches the icon as a <a href="https://en.wikipedia.org/wiki/Base64">base64</a> <code>data:</code> URI (search plug-ins are stored in the <a href="/en-US/docs/Mozilla/Profile_Manager">profile</a>'s <code>searchplugins/</code> folder). <code>http:</code> and <code>https:</code> URLs are converted to <code>data:</code> URIs when this is done.</p>

 <div class="note"><strong>Note:</strong> For icons loaded remotely (that is, from <code>https://</code> URIs as opposed to <code>data:</code> URIs), Firefox will reject icons larger than <strong>10 kilobytes</strong>.</div>

 <p><img alt="Search suggestions from Google displayed in Firefox's search box" class="internal" src="/@api/deki/files/358/=SearchSuggestionSample.png"></p>
 </dd>
 <dt>Url</dt>
 <dd>Describes the URL or URLs to use for the search. The <code>template</code> attribute indicates the base URL for the search query.</dd>
 <dd>Firefox supports three URL types:
 <ul>
  <li><code>type="text/html"</code> specifies the URL for the actual search query.</li>
  <li><code>type="application/x-suggestions+json"</code> specifies the URL for fetching search suggestions. In Firefox 63 onwards, <code>type="application/json"</code> is accepted as an alias of this.</li>
  <li><code>type="application/x-moz-keywordsearch"</code> specifies the URL used when a keyword search is entered in the location bar. This is supported only in Firefox.</li>
 </ul>

 <p>For these URL types, you can use <code>{searchTerms}</code> to substitute the search terms entered by the user in the search bar or location bar. Other supported dynamic search parameters are described in <a class="external" href="http://www.opensearch.org/Specifications/OpenSearch/1.1/Draft_3#OpenSearch_1.1_parameters">OpenSearch 1.1 parameters</a>.</p>

 <p>For search suggestions, the <code>application/x-suggestions+json</code> URL template is used to fetch a suggestion list in <a href="/en-US/docs/Glossary/JSON">JSON</a> format. For details on how to implement search suggestion support on a server, see <a href="/en-US/docs/Archive/Add-ons/Supporting_search_suggestions_in_search_plugins">Supporting search suggestions in search plugins</a>.</p>
 </dd>
 <dt>Param</dt>
 <dd>The parameters that must be passed in along with the search query as key/value pairs. When specifying values, you can use <code>{searchTerms}</code> to insert the search terms entered by the user in the search bar.</dd>
 <dt>moz:SearchForm</dt>
 <dd>The URL for the site's search page for which the plugin. This lets Firefox users visit the web site directly.</dd>
 <dd>
 <div class="note"><strong>Note:</strong> Since this element is Firefox-specific, and not part of the OpenSearch specification, we use the <code>moz:</code> XML namespace prefix in the example above to ensure that other user agents that don't support this element can safely ignore it.</div>
 </dd>
</dl>

<h2 id="Autodiscovery_of_search_plugins">Autodiscovery of search plugins</h2>

<p>Web sites with search plugins can advertise them so Firefox users can easily install the plugins.</p>

<p>To support autodiscovery, add a <code>&lt;link&gt;</code> element for each plugin to the <code>&lt;head&gt;</code> of your web page:</p>

<pre class="brush: html; highlight[3-4]">&lt;link rel="search"
      type="application/opensearchdescription+xml"
      title="<mark><strong>searchTitle</strong></mark>"
      href="<mark><strong>pluginURL</strong></mark>"&gt;
</pre>

<p>Replace the bolded items as explained below:</p>

<dl>
 <dt>searchTitle</dt>
 <dd>The name of the search to perform, such as "Search MDC" or "Yahoo! Search". This must match your plugin file's <code>&lt;ShortName&gt;</code>.</dd>
 <dt>pluginURL</dt>
 <dd>The URL to the XML search plugin, so the browser can download it.</dd>
</dl>

<p>If your site offers multiple search plugins, you can support autodiscovery for them all. For example:</p>

<pre class="brush: html">&lt;link rel="search" type="application/opensearchdescription+xml"
      title="MySite: By Author" href="http://example.com/mysiteauthor.xml"&gt;

&lt;link rel="search" type="application/opensearchdescription+xml"
      title="MySite: By Title" href="http://example.com/mysitetitle.xml"&gt;
</pre>

<p>This way, your site can offer plugins to search by author, or by title.</p>

<div class="note">
<p>In Firefox, an icon change in the search box indicates there's a provided search plugin. (See image, the green plus sign.) Thus if a search box is not shown in the user's UI, they will receive <em>no </em>indication. <em>In general, behavior varies among browsers</em>.</p>
<img alt="How search plugin availabitity is shown in Firefox" src="https://mdn.mozillademos.org/files/16679/new.png" style="height: 164px; width: 885px;"></div>

<h2 id="Supporting_automatic_updates_for_OpenSearch_plugins">Supporting automatic updates for OpenSearch plugins</h2>

<p>OpenSearch plugins can automatically update. To support this, include an extra <code>Url</code> element with <code>type="application/opensearchdescription+xml"</code> and <code>rel="self"</code>. The <code>template</code> attribute should be the URL of the OpenSearch document to automatically update to.</p>

<p>For example:</p>

<pre class="brush: xml">&lt;Url type="application/opensearchdescription+xml"
     rel="self"
     template="https://example.com/mysearchdescription.xml" /&gt;
</pre>

<div class="note"><strong>Note:</strong> At this time, <a class="external" href="https://addons.mozilla.org">addons.mozilla.org</a> (AMO) doesn't support automatic updating of OpenSearch plugins. If you want to put your search plugin on AMO, remove the auto-updating feature before submitting it.</div>

<h2 id="Troubleshooting_Tips">Troubleshooting Tips</h2>

<p>If there is a mistake in your Search Plugin XML, you could run into errors when adding a discovered plugin. If the error message isn't be helpful, the following tips could help you find the problem.</p>

<ul>
 <li>Your server should serve OpenSearch plugins using <code>Content-Type: application/opensearchdescription+xml</code>.</li>
 <li>Be sure that your Search Plugin XML is well formed. You can check by loading the file directly into Firefox. Ampersands (&amp;) in the <code>template</code> URL must be escaped as <code>&amp;amp;</code>, and tags must be closed with a trailing slash or matching end tag.</li>
 <li>The <code>xmlns</code> attribute is important — without it you could get the error message "Firefox could not download the search plugin".</li>
 <li>You <strong>must</strong> include a <code>text/html</code> URL — search plugins including only Atom or <a href="/en/RSS">RSS</a> URL types (which is valid, but Firefox doesn't support) will also generate the "could not download the search plugin" error.</li>
 <li>Remotely fetched favicons must not be larger than 10KB (see {{ Bug(361923) }}).</li>
</ul>

<p>In addition, the search plugin service provides a logging mechanism that may be useful to plugin developers. Use <code>about:config</code> to set the pref '<code>browser.search.log</code>' to <code>true</code>. Then, logging information will appear in Firefox's <a href="/en-US/docs/Archive/Mozilla/Error_console">Error Console</a> (Tools ➤ Error Console) when search plugins are added.</p>

<h2 id="Reference_Material">Reference Material</h2>

<ul>
 <li><a href="https://github.com/dewitt/opensearch">OpenSearch Documentation</a></li>
 <li><a href="https://developer.apple.com/library/archive/releasenotes/General/WhatsNewInSafari/Articles/Safari_8_0.html">Safari 8.0 Release Notes: Quick Website Search</a></li>
 <li><a href="https://docs.microsoft.com/en-us/microsoft-edge/dev-guide/browser-features/search-provider-discovery">Microsoft Edge Dev Guide: Search provider discovery</a></li>
 <li><a href="https://www.chromium.org/tab-to-search">The Chromium Projects: Tab to Search</a></li>
 <li>imdb.com has a <a class="external" href="https://m.media-amazon.com/images/G/01/imdb/images/imdbsearch-3349468880._CB470047351_.xml">working <code>osd.xml</code></a></li>
 <li><a class="external" href="http://www.7is7.com/software/firefox/opensearch.html">OpenSearch Plugin Generator</a></li>
 <li><a class="external" href="http://ready.to/search/en">Ready2Search</a> - create OpenSearch plugins. <a class="external" href="http://ready.to/search/make/en_make_plugin.htm">Customized Search through Ready2Search</a></li>
</ul>
